//package toast;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.lang.*;

/**
 *
 * @author
 * @version
 */
public class UnitPropertiesJFrame extends javax.swing.JFrame {

  private JColorChooser colorChooser = new JColorChooser();
  private Properties props = new Properties();
  

  /** Initializes the Form */
  public UnitPropertiesJFrame() {
    setVisible(false);
    props = loadProperties("UnitProperties.props");

    initComponents ();
    setValuesToProperties(props);

    pack ();
    setLocation(100,100);
    setSize(396 ,470);
  }
  public UnitPropertiesJFrame(Properties props) {
    setVisible(false);
    setDefaultCloseOperation(DISPOSE_ON_CLOSE);

    this.props = props;
    initComponents ();
    setValuesToProperties(props);

    pack ();
    setLocation(100,100);
    setSize(396 ,470);
  }

  private void initVisibilityComboBox(JComboBox box){
    box.addItem("never");
    box.addItem("if activated");
    box.addItem("always");
  }
  private void initColormodeComboBox(JComboBox box){
    box.addItem("color");
  }
  private void initShapeComboBox(JComboBox box){
    box.addItem("no outline");
    box.addItem("box");
    box.addItem("rounded box");
    box.addItem("circle");
  }
  private void initLineComboBox(JComboBox box){
    box.addItem("no line");
    box.addItem("solid");
  }
  private void initDataLabel(JLabel label, int i) {
     if (i==0) label.setText("number");
     else if (i==1) label.setText("typeName");
     else if (i==2) label.setText("unitName");
     else if (i==3) label.setText("act");
     else if (i==4) label.setText("bias");
     else if (i==5) label.setText("st");
     else if (i==6) label.setText("position");
     else if (i==7) label.setText("act func");
     else if (i==8) label.setText("out func");
     else if (i==9) label.setText("sites");
     else  label.setText("unknown");
  }
    
  public void setData(Unit u) {
     for (int i = 0; i <10; i++) {
	valueTextField[i].setText(u.getValueText(i));
     }
  } 

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {
    setVisible (true);
    addWindowListener (new java.awt.event.WindowAdapter () {
        public void windowClosing (java.awt.event.WindowEvent evt) {
          exitForm(evt);
        }
      }
    );
    getContentPane ().setLayout (new java.awt.FlowLayout (0, 5, 5));


    jTabbedPane1 = new javax.swing.JTabbedPane ();

      valueTabPanel = new javax.swing.JPanel ();
      valueTabPanel.setToolTipText ("null");
      valueTabPanel.setPreferredSize (new java.awt.Dimension(300, 350));
      valueTabPanel.setMinimumSize (new java.awt.Dimension(300, 350));
      valueTabPanel.setLayout (new java.awt.GridLayout (11, 1, 0,0));


// init first Tab Panel :

        valuePanel[0] = new javax.swing.JPanel ();
        valuePanel[0].setPreferredSize (new java.awt.Dimension(72, 17));
        valuePanel[0].setMinimumSize (new java.awt.Dimension(72, 17));
        valuePanel[0].setMaximumSize  (new java.awt.Dimension(72, 17));

        valuePanel[0].setLayout (new java.awt.FlowLayout (FlowLayout.LEFT, 5, 5));
          jLabel1 = new javax.swing.JLabel ();
          jLabel1.setPreferredSize (new java.awt.Dimension(72, 17));
          jLabel1.setText ("name");
          valuePanel[0].add (jLabel1);

          jLabel2 = new javax.swing.JLabel ();
          jLabel2.setPreferredSize (new java.awt.Dimension(72, 17));
	  jLabel2.setText ("value");
          valuePanel[0].add (jLabel2);

          jLabel3 = new javax.swing.JLabel ();
          jLabel3.setPreferredSize (new java.awt.Dimension(130, 17));
          jLabel3.setText ("visibel");
          valuePanel[0].add (jLabel3);

        valueTabPanel.add (valuePanel[0]);


        for (int i=0; i<10; i++) {
            valuePanel[i+1]  = new javax.swing.JPanel ();
            valuePanel[i+1].setPreferredSize (new java.awt.Dimension(72, 17));
            valuePanel[i+1].setMinimumSize (new java.awt.Dimension(72, 17));
            valuePanel[i+1].setMaximumSize  (new java.awt.Dimension(72, 17));
            valuePanel[i+1].setLayout (new java.awt.FlowLayout (FlowLayout.LEFT, 5, 5));

                      dataLabel[i] = new javax.swing.JLabel ();//"Label "+i);
	              initDataLabel(dataLabel[i],i);
                      dataLabel[i].setPreferredSize (new java.awt.Dimension(72, 17));
                      dataLabel[i].setMaximumSize (new java.awt.Dimension(72, 17));
                      dataLabel[i].setMinimumSize (new java.awt.Dimension(72, 17));
                valuePanel[i+1].add (dataLabel[i]);
                      valueTextField[i] = new javax.swing.JTextField ();
	              valueTextField[i].setEditable(false);
		      valueTextField[i].setPreferredSize (new java.awt.Dimension(72, 17));
                      valueTextField[i].setMaximumSize (new java.awt.Dimension(72, 17));
                      valueTextField[i].setMinimumSize (new java.awt.Dimension(72, 17));
                valuePanel[i+1].add (valueTextField[i]);
                      visibilityComboBox[i] = new javax.swing.JComboBox ();
                      visibilityComboBox[i].setActionCommand (""+i);
		      initVisibilityComboBox(visibilityComboBox[i]);
                valuePanel[i+1].add (visibilityComboBox[i]);

            valueTabPanel.add (valuePanel[i+1]);
        }
 
        visibilityComboBox[0].setEnabled(false);
        visibilityComboBox[0].setSelectedIndex(2);

      jTabbedPane1.addTab ("Data", new javax.swing.ImageIcon (""), valueTabPanel);


// init second Tab-Pane:

      colorTabPanel = new javax.swing.JPanel ();
      colorTabPanel.setToolTipText ("null");
      colorTabPanel.setPreferredSize (new java.awt.Dimension(380, 350));
      colorTabPanel.setMinimumSize (new java.awt.Dimension(380, 350));
      colorTabPanel.setLayout (new java.awt.GridLayout (11, 1, 0,0));


	colorPanel[0] = new javax.swing.JPanel ();
        colorPanel[0].setLayout (new java.awt.FlowLayout (FlowLayout.LEFT, 5, 5));


          jLabel4 = new javax.swing.JLabel ();
          jLabel4.setPreferredSize (new java.awt.Dimension(72, 17));
          jLabel4.setText ("name");
          colorPanel[0].add (jLabel4);

          jLabel5 = new javax.swing.JLabel ();
          jLabel5.setText ("active");
          colorPanel[0].add (jLabel5);

          jLabel6 = new javax.swing.JLabel ();
          jLabel6.setPreferredSize (new java.awt.Dimension(69, 17));
          jLabel6.setText ("inactive");
          colorPanel[0].add (jLabel6);

          jLabel7 = new javax.swing.JLabel ();
          jLabel7.setPreferredSize (new java.awt.Dimension(117, 17));
          jLabel7.setText ("colormode");
          colorPanel[0].add (jLabel7);

        colorTabPanel.add (colorPanel[0]);

	for (int i=0; i<10; i++) {
	
            colorPanel[i+1] = new javax.swing.JPanel ();
            colorPanel[i+1].setPreferredSize (new java.awt.Dimension(72, 17));
            colorPanel[i+1].setMinimumSize (new java.awt.Dimension(72, 17));
            colorPanel[i+1].setMaximumSize  (new java.awt.Dimension(72, 17));
            colorPanel[i+1].setLayout (new java.awt.FlowLayout (FlowLayout.LEFT, 5, 5));

		dataLabel[i+10] = new javax.swing.JLabel ();
		initDataLabel(dataLabel[i+10], i);
                dataLabel[i+10].setPreferredSize (new java.awt.Dimension(72, 17));
                dataLabel[i+10].setMaximumSize (new java.awt.Dimension(72, 17));
                dataLabel[i+10].setMinimumSize (new java.awt.Dimension(72, 17));
	    colorPanel[i+1].add ( dataLabel[i+10] );

                activeColorButton[i] = new javax.swing.JButton ();
                activeColorButton[i].setText (" ");
                activeColorButton[i].setActionCommand ("activeColorButton"+i);
                activeColorButton[i].setLabel (" ");
		activeColorButton[i].addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      colorButtonActionPerformed (evt);
                    }

                  }
                );
            colorPanel[i+1].add (activeColorButton[i]);

                inactiveColorButton[i] = new javax.swing.JButton ();
                inactiveColorButton[i].setText (" ");
                inactiveColorButton[i].setActionCommand ("inactiveColorButton"+i);
                inactiveColorButton[i].setLabel (" ");
                inactiveColorButton[i].addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      colorButtonActionPerformed (evt);
                    }
                  }
                );
            colorPanel[i+1].add (inactiveColorButton[i]);

		colorModeComboBox[i] = new javax.swing.JComboBox ();
                initColormodeComboBox( colorModeComboBox[i] );
	    colorPanel[i+1].add (colorModeComboBox[i]);

	    colorTabPanel.add (colorPanel[i+1]);

	}


      jTabbedPane1.addTab ("Color", colorTabPanel);


//  init third Tab-Panel

      shapeTabPanel = new javax.swing.JPanel ();
      shapeTabPanel.setName ("Shape");
      shapeTabPanel.setLayout (new java.awt.GridLayout (11, 1));

        shapePanel[0] = new javax.swing.JPanel ();
        shapePanel[0].setLayout (new java.awt.FlowLayout (0, 5, 5));

          jLabel8 = new javax.swing.JLabel ();
          jLabel8.setPreferredSize (new java.awt.Dimension(72, 17));
          jLabel8.setText ("name");
          shapePanel[0].add (jLabel8);

          jLabel9 = new javax.swing.JLabel ();
          jLabel9.setPreferredSize (new java.awt.Dimension(42, 17));
          jLabel9.setText ("shape");
          shapePanel[0].add (jLabel9);

          jLabel10 = new javax.swing.JLabel ();
          jLabel10.setText ("line");
          shapePanel[0].add (jLabel10);

          jLabel11 = new javax.swing.JLabel ();
          jLabel11.setPreferredSize (new java.awt.Dimension(41, 17));
          jLabel11.setText ("sticky");
          shapePanel[0].add (jLabel11);

        shapeTabPanel.add (shapePanel[0]);

      for (int i=0; i<10; i ++) {

        shapePanel[i+1] = new javax.swing.JPanel ();
        shapePanel[i+1].setLayout (new java.awt.FlowLayout (0, 5, 0));

          dataLabel[i+20] = new javax.swing.JLabel ();
	  initDataLabel(dataLabel[i+20], i);
          dataLabel[i+20].setPreferredSize (new java.awt.Dimension(72, 17));
          dataLabel[i+20].setMaximumSize (new java.awt.Dimension(72, 17));
          dataLabel[i+20].setMinimumSize (new java.awt.Dimension(72, 17));
          shapePanel[i+1].add (dataLabel[i+20]);

          shapeComboBox[i] = new javax.swing.JComboBox ();
          shapeComboBox[i].setActionCommand ("shapeComboBox"+i);
          initShapeComboBox( shapeComboBox[i] );
          shapePanel[i+1].add (shapeComboBox[i]);

          lineComboBox[i] = new javax.swing.JComboBox ();
          lineComboBox[i].setActionCommand ("lineComboBox"+i);
          initLineComboBox(lineComboBox[i]);
          shapePanel[i+1].add (lineComboBox[i]);

          stickyCheckBox[i] = new javax.swing.JCheckBox ();
          shapePanel[i+1].add (stickyCheckBox[i]);

        shapeTabPanel.add (shapePanel[i+1]);

        //posx[i] = new Integer();
        //posy[i] = new Integer();

      }

      stickyCheckBox[0].setEnabled(false); 

      jTabbedPane1.addTab ("Shape", shapeTabPanel);



    getContentPane ().add (jTabbedPane1);

    buttonPanel = new javax.swing.JPanel ();
    buttonPanel.setLayout (new java.awt.FlowLayout (FlowLayout.CENTER, 5, 5));

      defaultButton = new javax.swing.JButton ();
      defaultButton.setText ("default");
      defaultButton.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            defaultButtonActionPerformed (evt);
          }
        }
      );
      buttonPanel.add (defaultButton);

      applyButton = new javax.swing.JButton ();
      applyButton.setText ("apply");
      applyButton.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            applyButtonActionPerformed (evt);
          }
        }
      );
      buttonPanel.add (applyButton);

      closeButton = new javax.swing.JButton ();
      closeButton.setText ("close");
      closeButton.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            closeButtonActionPerformed (evt);
          }
        }
      );
      buttonPanel.add (closeButton);

      saveAsDefaultButton = new javax.swing.JButton ();
      saveAsDefaultButton.setText ("save as default");
      saveAsDefaultButton.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            saveAsDefaultButtonActionPerformed (evt);
          }
        }
      );

      buttonPanel.add (saveAsDefaultButton);

    getContentPane ().add (buttonPanel);

}




//ActionHandler

  private void closeButtonActionPerformed (java.awt.event.ActionEvent evt) {
      // Add your handling code here
      System.out.println("Close window");
      UnitPropertiesJFrame.this.setVisible(false);
      //UnitPropertiesJFrame.this.dispose();
      //System.exit(0);
  }

  private void saveAsDefaultButtonActionPerformed (java.awt.event.ActionEvent evt) {
    saveProperties(this.getProperties(),"UnitProperties.props");	
  }

  private void applyButtonActionPerformed(java.awt.event.ActionEvent evt) {
    System.out.println("Apply pressed (UnitPropertiesJFrame)");
  }

  private void defaultButtonActionPerformed(java.awt.event.ActionEvent evt) {
    loadProperties("UnitProperties.props");
    setValuesToProperties(props);
  }
 
  private void colorButtonActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
    System.out.println("Action occured: "+evt.getActionCommand());
    changeColor((JButton)evt.getSource());
  }


//PropertiesFunctions


  public void setValuesToProperties(Properties props){
      for (int i=0; i<10; i++) {
	  visibilityComboBox[i].setSelectedIndex(Integer.parseInt(props.getProperty("Visibility"+i)));
          activeColorButton[i].setBackground(new Color(Integer.parseInt(props.getProperty("activeColor"+i))));
          inactiveColorButton[i].setBackground(new Color(Integer.parseInt(props.getProperty("inactiveColor"+i))));
	  colorModeComboBox[i].setSelectedIndex(Integer.parseInt(props.getProperty("coloMode"+i)));
	  shapeComboBox[i].setSelectedIndex(Integer.parseInt(props.getProperty("shape"+i)));
	  lineComboBox[i].setSelectedIndex(Integer.parseInt(props.getProperty("line"+i)));
	  if (!props.getProperty("sticky"+i).equals(String.valueOf(stickyCheckBox[i].isSelected()))) {
		stickyCheckBox[i].doClick();
	  }
	  posx[i] = Integer.valueOf(props.getProperty("posx"+i,"0"));
          posy[i] = Integer.valueOf(props.getProperty("posy"+i,"0"));
      }
  }

  public Properties getProperties(){
      for (int i=0; i<10; i++) {
          props.setProperty ("Visibility"+i, Integer.toString(visibilityComboBox[i].getSelectedIndex()));
          props.setProperty ("activeColor"+i, Integer.toString(activeColorButton[i].getBackground().getRGB()));
          props.setProperty ("inactiveColor"+i, Integer.toString(inactiveColorButton[i].getBackground().getRGB()));
          props.setProperty ("coloMode"+i, Integer.toString(colorModeComboBox[i].getSelectedIndex()));
          props.setProperty ("shape"+i, Integer.toString(shapeComboBox[i].getSelectedIndex()));
          props.setProperty ("line"+i, Integer.toString(lineComboBox[i].getSelectedIndex()));
          props.setProperty ("sticky"+i, String.valueOf(stickyCheckBox[i].isSelected()));
          props.setProperty ("posx"+i, posx[i].toString());
          props.setProperty ("posy"+i, posy[i].toString());
      }
      props.setProperty ("sticky0","false");
      return props;
  }

  private Properties loadProperties(String FileName) {
    Properties p = new Properties();
    try {
        FileInputStream in = new FileInputStream(FileName);
        p.load(in);
        in.close();
    }
    catch  (FileNotFoundException e) {}
    catch  (IOException e) {}

    return p;
  }

  private void saveProperties(Properties props,String FileName) {
    try {
      FileOutputStream out = new FileOutputStream(FileName);
      props.store(out, "---UnitProperties.Props---");
      out.close();
    }
    catch (IOException e) {}
  }





  private void changeColor (JButton button) {
    Color c = new Color(0);
    c = colorChooser.showDialog(this, "select color",button.getBackground());
    if (c != null) {
      button.setBackground(c);
    }
  }

  public JButton getApplyButton() {
      return applyButton;
  }



  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.out.println("Close window");
      UnitPropertiesJFrame.this.setVisible(false);

    //System.exit (0);
  }//GEN-LAST:event_exitForm


// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JTabbedPane jTabbedPane1;
  private javax.swing.JPanel buttonPanel;
  private javax.swing.JButton defaultButton;
  private javax.swing.JButton applyButton;
  private javax.swing.JButton closeButton;
  private javax.swing.JButton saveAsDefaultButton;



  private javax.swing.JPanel valueTabPanel;
    private javax.swing.JPanel[] valuePanel = new javax.swing.JPanel[11];
      private javax.swing.JLabel jLabel1;
      private javax.swing.JLabel jLabel2;
      private javax.swing.JLabel jLabel3;

      private javax.swing.JLabel[] dataLabel =new javax.swing.JLabel[30];
      private javax.swing.JTextField[] valueTextField = new javax.swing.JTextField[10];
      private javax.swing.JComboBox[] visibilityComboBox = new javax.swing.JComboBox[10];


  private javax.swing.JPanel colorTabPanel;
    private javax.swing.JPanel[] colorPanel = new javax.swing.JPanel[11]; 
      private javax.swing.JLabel jLabel4;
      private javax.swing.JLabel jLabel5;
      private javax.swing.JLabel jLabel6;
      private javax.swing.JLabel jLabel7;

      private javax.swing.JButton[] activeColorButton = new javax.swing.JButton[10];
      private javax.swing.JButton[] inactiveColorButton = new javax.swing.JButton[10];
      private javax.swing.JComboBox[] colorModeComboBox = new javax.swing.JComboBox[10];

  private javax.swing.JPanel shapeTabPanel;
    private javax.swing.JPanel[] shapePanel = new javax.swing.JPanel[11];
      private javax.swing.JLabel jLabel8;
      private javax.swing.JLabel jLabel9;
      private javax.swing.JLabel jLabel10;
      private javax.swing.JLabel jLabel11;

      private javax.swing.JComboBox[] shapeComboBox = new javax.swing.JComboBox[10];
      private javax.swing.JCheckBox[] stickyCheckBox = new javax.swing.JCheckBox[10];
      private javax.swing.JComboBox[] lineComboBox = new javax.swing.JComboBox[10];

   private Integer[] posx = new Integer[10];
   private Integer[] posy = new Integer[10];


// End of variables declaration//GEN-END:variables


  public static void main(java.lang.String[] args) {
    new UnitPropertiesJFrame ().show ();
  }

}
